#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>

#include <fstream>
#include <iostream>
#include <cstring>
using namespace std;

void haeSaa(char *pk);
char *yksikko(char *m);

int main(int argc, char *argv[])
{
  if(argc != 0)
    haeSaa("Espoo");
  else
    return 1;
  return 0;
}

void haeSaa(char *pk)
{
  int sock;
  sockaddr_in sa;
  char base[] = "GET /saa/paikalli.html\?kunta=%s\r\n\r\n HTTP/1.0\r\n\r\n";
  char bf[1000] = "";
  char name[] = "www.ilmatieteenlaitos.fi";
  int j,i,n,k,l; // vastaanotettujen merkkien mr
  bool hit=false;

  sprintf(bf,base,pk); // tallennetaan pyyntn paikkakunta

  // gets several lines

  char bf2[][1000] = {"","","","","","",""};
  char *vname[10] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
  char *value[10], *paikka, *klo, *pvm, *testi;
    //, *lt, *paine, *kosteus, *tuuli, *testi;
  //        cout << "pyynt: " << bf << endl;

  sock = socket( PF_INET, SOCK_STREAM, 0 );

  sa.sin_family = AF_INET;
  sa.sin_port = htons( 80 );
  sa.sin_addr = (in_addr&)*(gethostbyname( name )->h_addr_list[0]);
  connect( sock, (sockaddr*)&sa, sizeof(sa) );

  send( sock, bf, strlen(bf), 0 );
	
  //        cout << "Saatiin:\n";
  i=0;
  j=0;
  k=0;
  l=0;
  while ((n = recv( sock, bf, 999, 0 )) > 0)
    {
      bf[n] = 0;

      for(i=0;  i<1000; i++)
      {
	if(bf[i] == '\n')
	{
	  bf2[j][k] = 0;
      
	  testi = &bf2[j][0];

	  if(!hit)
	    {
	      for(l=0; bf2[j][l] != ' ' && l<=k; l++ );
	      if(bf2[j][l] == ' ')
		{
		  bf2[j][l]= 0;
		  paikka = &bf2[j][++l];
		}
	      if(!strcmp(testi,"\n<B>Havaintoasema:"))
		{
		  j++;
		  hit = true;
		}
	    }
	  //	  	  cout << bf2[j] << "111111"<< endl << "#####" << endl;
	  // cout << testi << endl;
	  if(j>0)
	    j++;
	  if(j>6)
	    j=6;;
	  k=0;
	} 
	bf2[j][k++]=bf[i];
      }


    }
  //        cout << endl;

  close( sock );

  for(i=2;i<6;i++)
    cout << bf2[i] << "#####" << endl;

  
  //paikka
  i=0;
  for(i=0; paikka[i] != '<'; i++);
  paikka[i] = 0;
  cout << "paikka: " << paikka << endl;

  // aika
  for(i=0; bf2[2][i] != '>'; i++);
  i++;
  for(; bf2[2][i] != '>'; i++);
  i++;
  pvm = &bf2[2][i]; // pivmr
  for(; bf2[2][i] != ' '; i++);
  bf2[2][i] = 0;

  klo = &bf2[2][++i]; //kellon aika
  for(; bf2[2][i] != '<'; i++);
  bf2[2][i] = 0;

  
  i = 2;
  j=0;
  while( 1 )
  {
    cout << j << endl; 
    vname[j] = &bf2[3][i];
    for(; bf2[3][i] != '&'; i++);
    bf2[3][i] = 0;
    i++;

    for(; bf2[3][i] != '>'; i++);
    i++;
    value[j] = &bf2[3][i];
    for(; bf2[3][i] != '&'; i++);
    bf2[3][i] = 0;
    i++;
    for(; bf2[3][i] != '>'; i++);

    j++;
    i++;
    if(bf2[3][i] == 0)
      break;
    i++;
    if(bf2[3][i] == 0)
      break;
  }
  /*
  //lmptila
  for(i=0; bf2[3][i] != '>'; i++);
  i++;
  lt = &bf2[3][i];
  for(; bf2[3][i] != '&'; i++);

  //paine
  for(; bf2[3][i] != '>'; i++);
  i++;
  for(; bf2[3][i] != '>'; i++);
  i++;
  paine = &bf2[3][i];
  for(; bf2[3][i] != '&'; i++);
  bf2[3][i] = 0;

  //kosteus
  for(; bf2[3][i] != '>'; i++);
  i++;

  //tuuli
  for(; bf2[3][i] != '>'; i++);
  i++;
  for(; bf2[3][i] != '>'; i++);
  i ++;
  tuuli = &bf2[3][i];
  for(; bf2[3][i] != '&'; i++);
  bf2[3][i] = 0;

  */

  cout << paikka << endl;
  cout << pvm << klo << endl; 
  for(i=0; vname[i]!=NULL; i++)
  {
    cout << vname[i] << " " << value[i];
    cout << " " << yksikko(vname[i]) << endl;
  }
  /*
  cout << "Lampotila: " << lt << " astetta" << endl;
  cout << "Ilman paine: " << paine << " hPa"<< endl;
  cout << "Kosteus: " << kosteus << " %"<< endl;
  cout << "Tuuli: " << tuuli << " m/s"<< endl;
  */
}

char *yksikko(char *m)
{
  if(!strcmp(m,"kosteus"))
     return "%";
  else if(!strcmp(m,"lmptila"))
     return "C";
  else if(!strcmp(m,"paine"))
     return "hPa";
  else
     return "m/s";
}
