#include <engine.h>

#include <dockapp.h>
#include <unistd.h>

#include <string.h>


char *displayName = "";

static DAProgramOption options[] = {
    {"-display", NULL, "display to use", DOString, False, {&displayName} }
};

int main(int argc, char *argv[])
{
  //  saa Saa;
   Pixmap pixmap;

    GC gc;
    int i;

    DAParseArguments(argc, argv, options,
		     sizeof(options)/sizeof(DAProgramOption),
		     "WMFW dockapp", "WMFW 0.1");

    DAInitialize(displayName, "WMFW", 48, 48, argc, argv);

    pixmap = DAMakePixmap();
    gc = DefaultGC(DADisplay, DefaultScreen(DADisplay));

    DAShow();

    i = 0;
    while (1) {
	XEvent ev;
	char buf[50];
	
	//Saa.haeSaa("Lahti");

	sprintf(buf, "%s", "sdf");//Saa.paikka);

	XSetForeground(DADisplay, gc, 
		       BlackPixel(DADisplay, DefaultScreen(DADisplay)));
	XFillRectangle(DADisplay, pixmap, gc, 0, 0, 48, 48);

	XSetForeground(DADisplay, gc, 
		       WhitePixel(DADisplay, DefaultScreen(DADisplay)));

	XDrawString(DADisplay, pixmap, gc, 5, 24, buf, strlen(buf));

	DASetPixmap(pixmap);

	/* handle all pending X events */
	while (XPending(DADisplay)) {
	    XNextEvent(DADisplay, &ev);
	    DAProcessEvent(&ev);
	}

	sleep(60);
	i++;
    }
  return 0;
}
