#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <string.h>


#include "engine.h"


char *yksikko(char *m);
short int isValid(char *m);

char *value[10], *paikka, *klo, *pvm, *testi;
char *valname[10];
char bf[1000] = "";
char bf2[7][1000] = {"","","","","","",""};

void haeSaa(char *pk)
{
  int sock;
  char base[] = "GET /saa/paikalli.html\?kunta=%s\r\n\r\n HTTP/1.0\r\n\r\n";
  char name[] = "www.ilmatieteenlaitos.fi";
  int j,i,n,k,l; 
  short int hit=FALSE;
  struct sockaddr_in sa;
  struct hostent *he;

  printf("paikka1\n");

  sprintf(bf,base,pk); /* tallennetaan pyyntn paikkakunta*/

  for(i=0;i<10;i++)
    valname[i]=NULL;

  sock = socket( PF_INET, SOCK_STREAM, 0 );

  printf("paikka2\n");

  sa.sin_family = AF_INET;
  sa.sin_port = htons( 80 );

  he = gethostbyname( name );
  bcopy((char *)he->h_addr, 
         (char *)&sa.sin_addr.s_addr,
         he->h_length);
  printf("paikka3\n");

  /*sa.sin_addr = ai; 
   */
  connect( sock, (struct sockaddr *)&sa, sizeof(sa) );

  send( sock, bf, strlen(bf), 0 );
	
  i=0;
  j=0;
  k=0;
  l=0;
  while ((n = recv( sock, bf, 999, 0 )) > 0)
    {
      bf[n] = 0;

      for(i=0;  i<n; i++)
      {
	if(bf[i] == '\n')
	{
	  bf2[j][k] = 0;
      
	  testi = &bf2[j][0];

	  if(!hit)
	    {
	      for(l=0; bf2[j][l] != ' ' && l<=k; l++ );
	      if(bf2[j][l] == ' ')
		{
		  bf2[j][l]= 0;
		  paikka = &bf2[j][++l];
		}
	      if(!strcmp(testi,"\n<B>Havaintoasema:"))
		{
		  j++;
		  hit = TRUE;
		}
	    }
	  if(j>0)
	    j++;
	  if(j>6)
	    j=6;;
	  k=0;
	} 
	bf2[j][k++]=bf[i];
      }


    }

  close( sock );

  /*paikka*/
  i=0;
  k=1;
  for(i=0; paikka[i] != '<'; i++);
  paikka[i] = 0;
  printf("%s\n",paikka);

  testi = &bf2[k][0];
  for(i=0; bf2[k][i] != ' '; i++);
  bf2[k][i] = 0;
  if(strcmp(testi,"\nTuorein"))
    k++;
  

  /* aika */
  for(i=0; bf2[k][i] != '>'; i++);
  i++;
  for(; bf2[k][i] != '>'; i++);
  i++;
  pvm = &bf2[k][i]; /* pivmr*/
  for(; bf2[k][i] != ' '; i++);
  bf2[k][i] = 0;

  klo = &bf2[k][++i]; /*kellon aika*/
  for(; bf2[k][i] != '<'; i++);
  bf2[k][i] = 0;

  i = 2;
  j=0;
  k++;

  while( 1 )
  {
    /* haetaan mre */
    valname[j] = &bf2[k][i];
    for(; bf2[k][i] != '&'; i++)
      if(bf2[k][i] == 0)
	break;
    
    
    bf2[k][i] = 0;
    i++;
    if(bf2[k][i] == 0)
      break;


    /* haetaan arvo */
    for(; bf2[k][i] != '>'; i++)
      if(bf2[k][i] == 0)
	break;
    i++;
    if(bf2[k][i] == 0)
      break;

    value[j] = &bf2[k][i];
    for(; bf2[k][i] != '&'; i++)
      if(bf2[k][i] == 0)
	break;

    bf2[k][i] = 0;
    i++;
    for(; bf2[k][i] != '>'; i++)
      if(bf2[k][i] == 0)
	break;

    /* katsotaan onko mre ok */
    if(isValid(valname[j]))
      j++;
    else
	valname[j] = NULL;
    i++;
    if(bf2[k][i] == 0)
      break;
    i++;
    if(bf2[k][i] == 0)
      break;
  }

  
  if((valname[j] != NULL) && !isValid(valname[j]))
    valname[j] = NULL;
  
  for(i=0; valname[i]!=NULL; i++)
  {
    /*ainakin pilvisyydest pois </B>*/
    for(j=0; value[i][j] != '<' && value[i][j] != 0; j++);
      value[i][j] = 0;

  }

}

char *yksikko(char *m)
{
  if(!strcmp(m,"kosteus"))
     return "%";
  if(!strcmp(m,"lmptila"))
     return "C";
  if(!strcmp(m,"sademr"))
     return "mm/h";
  if(!strcmp(m,"pilvisyys"))
     return "";
  if(!strcmp(m,"paine"))
     return "hPa";
  else
     return "m/s";
}

short int isValid(char *m)
{
  if(!strcmp(m,"kosteus"))
     return TRUE;
  if(!strcmp(m,"lmptila"))
     return TRUE;
  if(!strcmp(m,"sademr"))
     return TRUE;
  if(!strcmp(m,"paine"))
     return TRUE;
  if(!strcmp(m,"pilvisyys"))
     return TRUE;
  if(!strcmp(m,"pohjoistuulta"))
     return TRUE;
  if(!strcmp(m,"eteltuulta"))
     return TRUE;
  if(!strcmp(m,"ittuulta"))
     return TRUE;
  if(!strcmp(m,"lnsituulta"))
     return TRUE;
  if(!strcmp(m,"lounaistuulta"))
     return TRUE;
  if(!strcmp(m,"kaakkoistuulta"))
     return TRUE;
  if(!strcmp(m,"koillistuulta"))
     return TRUE;
  if(!strcmp(m,"luoteistuulta"))
     return TRUE;
  
  return FALSE;

}
