#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>

#include <fstream>
#include <iostream>
#include <cstring>
using namespace std;

void haeSaa(char *pk);
char *yksikko(char *m);
bool isValid(char *m);

int main(int argc, char *argv[])
{
  char kaupunki[30];

  if(argc > 1)
  {
    
    if(strlen(argv[1])<30)
      {
	//	muokkaaKau
	haeSaa(argv[1]);
      }
    else
      return 2;
  }
  else
    return 1;
  return 0;
}

void haeSaa(char *pk)
{
  int sock;
  sockaddr_in sa;
  char base[] = "GET /saa/paikalli.html\?kunta=%s\r\n\r\n HTTP/1.0\r\n\r\n";
  char bf[1000] = "";
  char name[] = "www.ilmatieteenlaitos.fi";
  int j,i,n,k,l; // vastaanotettujen merkkien mr
  bool hit=false;

  sprintf(bf,base,pk); // tallennetaan pyyntn paikkakunta

  // gets several lines

  char bf2[][1000] = {"","","","","","",""};
  char *vname[10] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
  char *value[10], *paikka, *klo, *pvm, *testi;
    //, *lt, *paine, *kosteus, *tuuli, *testi;
  //        cout << "pyynt: " << bf << endl;

  sock = socket( PF_INET, SOCK_STREAM, 0 );

  sa.sin_family = AF_INET;
  sa.sin_port = htons( 80 );
  sa.sin_addr = (in_addr&)*(gethostbyname( name )->h_addr_list[0]);
  connect( sock, (sockaddr*)&sa, sizeof(sa) );

  send( sock, bf, strlen(bf), 0 );
	
  i=0;
  j=0;
  k=0;
  l=0;
  while ((n = recv( sock, bf, 999, 0 )) > 0)
    {
      bf[n] = 0;

      for(i=0;  i<n; i++)
      {
	if(bf[i] == '\n')
	{
	  bf2[j][k] = 0;
      
	  testi = &bf2[j][0];

	  if(!hit)
	    {
	      for(l=0; bf2[j][l] != ' ' && l<=k; l++ );
	      if(bf2[j][l] == ' ')
		{
		  bf2[j][l]= 0;
		  paikka = &bf2[j][++l];
		}
	      if(!strcmp(testi,"\n<B>Havaintoasema:"))
		{
		  j++;
		  hit = true;
		}
	    }
	  //	  	  cout << bf2[j] << "111111"<< endl << "#####" << endl;
	  // cout << testi << endl;
	  if(j>0)
	    j++;
	  if(j>6)
	    j=6;;
	  k=0;
	} 
	bf2[j][k++]=bf[i];
      }


    }
  //        cout << endl;

  close( sock );
  //        cout << "Saatiin:\n";

  /*
    //tss on raaka teksti
  for(i=0;i<6;i++)
    cout << bf2[i] << "#endl" << endl;
  */
  
  //paikka
  i=0;
  k=1;
  for(i=0; paikka[i] != '<'; i++);
  paikka[i] = 0;
  //  cout << "paikka: " << paikka << endl;


  testi = &bf2[k][0];
  for(i=0; bf2[k][i] != ' '; i++);
  bf2[k][i] = 0;
  if(strcmp(testi,"\nTuorein"))
    k++;
  //cout << endl << testi << "####";
  

  // aika
  for(i=0; bf2[k][i] != '>'; i++);
  i++;
  for(; bf2[k][i] != '>'; i++);
  i++;
  pvm = &bf2[k][i]; // pivmr
  for(; bf2[k][i] != ' '; i++);
  bf2[k][i] = 0;

  klo = &bf2[k][++i]; //kellon aika
  for(; bf2[k][i] != '<'; i++);
  bf2[k][i] = 0;

  i = 2;
  j=0;
  k++;

  while( 1 )
  {
    // haetaan mre
    vname[j] = &bf2[k][i];
    for(; bf2[k][i] != '&'; i++)
      if(bf2[k][i] == 0)
	break;
    
    
    bf2[k][i] = 0;
    i++;
    if(bf2[k][i] == 0)
      break;


    // haetaan arvo
    for(; bf2[k][i] != '>'; i++)
      if(bf2[k][i] == 0)
	break;
    i++;
    if(bf2[k][i] == 0)
      break;

    value[j] = &bf2[k][i];
    for(; bf2[k][i] != '&'; i++)
      if(bf2[k][i] == 0)
	break;

    bf2[k][i] = 0;
    i++;
    for(; bf2[k][i] != '>'; i++)
      if(bf2[k][i] == 0)
	break;

    // katsotaan onko mre ok
    if(isValid(vname[j]))
      j++;
    else
	vname[j] = NULL;
    i++;
    if(bf2[k][i] == 0)
      break;
    i++;
    if(bf2[k][i] == 0)
      break;
  }

  
  if((vname[j] != NULL) && !isValid(vname[j]))
    vname[j] = NULL;
  
  cout << paikka << endl;
  cout << pvm << " " << klo << endl; 
  for(i=0; vname[i]!=NULL; i++)
  {
    //ainakin pilvisyydest pois </B>
    for(j=0; value[i][j] != '<' && value[i][j] != 0; j++);
      value[i][j] = 0;

    cout << vname[i] << " " << value[i];
    cout << " " << yksikko(vname[i]) << endl;
  }

}

char *yksikko(char *m)
{
  if(!strcmp(m,"kosteus"))
     return "%";
  else if(!strcmp(m,"lmptila"))
     return "C";
  else if(!strcmp(m,"sademr"))
     return "mm/h";
  else if(!strcmp(m,"pilvisyys"))
     return "";
  else if(!strcmp(m,"paine"))
     return "hPa";
  else
     return "m/s";
}

bool isValid(char *m)
{
  if(!strcmp(m,"kosteus"))
     return true;
  else if(!strcmp(m,"lmptila"))
     return true;
  else if(!strcmp(m,"sademr"))
     return true;
  else if(!strcmp(m,"paine"))
     return true;
  else if(!strcmp(m,"pilvisyys"))
     return true;
  else if(!strcmp(m,"pohjoistuulta"))
     return true;
  else if(!strcmp(m,"eteltuulta"))
     return true;
  else if(!strcmp(m,"ittuulta"))
     return true;
  else if(!strcmp(m,"lnsituulta"))
     return true;
  else if(!strcmp(m,"lounaistuulta"))
     return true;
  else if(!strcmp(m,"kaakkoistuulta"))
     return true;
  else if(!strcmp(m,"koillistuulta"))
     return true;
  else if(!strcmp(m,"luoteistuulta"))
     return true;
  else
    return false;

}
